"use strict";
/*
Create a .c file that exports a function that returns a pointer to
all libc function.  You must include this C code with any other code
you're compiling to build your main file if you want the dynamic
libraries you link to have access to libc.

This adds about 650KB to the wasm file (after stripping), which sucks,
but it is what it is.
*/
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var wasm_export_1 = __importDefault(require("./wasm-export"));
function main() {
    var e_1, _a;
    var s = "\n/* DO NOT EDIT: THIS CODE IS AUTOGENERATED. */\n\n#define _WASI_EMULATED_MMAN\n#define _WASI_EMULATED_SIGNAL\n#define _WASI_EMULATED_PROCESS_CLOCKS\n#define _WASI_EMULATED_GETPID\n";
    try {
        for (var _b = __values(headers.split("\n")), _c = _b.next(); !_c.done; _c = _b.next()) {
            var header = _c.value;
            if (!header.trim())
                continue;
            s += "#include<".concat(header, ">\n");
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // Some symbols aren't declared in headers that you can import without
    // causing trouble, but are still built, so we declare them here:
    // They aren't declared in the headers due to
    //   #ifdef __wasilibc_unmodified_upstream or #ifdef _GNU_SOURCE
    // Some (like iprintf) are just due to weak_alias.
    s += "\n// Undeclared things that do exist in libc-wasi-zig:\n\nchar *ecvt(double, int, int *, int *);\nchar *fcvt(double, int, int *, int *);\nchar *gcvt(double, int, char *);\nchar *secure_getenv(const char *);\ndouble      exp10(double);\nfloat       exp10f(float);\nlong double exp10l(long double);\nvoid        sincos(double, double*, double*);\nvoid        sincosf(float, float*, float*);\nvoid        sincosl(long double, long double*, long double*);\ndouble      pow10(double);\nfloat       pow10f(float);\nlong double pow10l(long double);\nFILE *fopencookie(void *, const char *, cookie_io_functions_t);\nint getdomainname(char *, size_t);\nvoid *memmem(const void *, size_t, const void *, size_t);\nchar *strcasestr(const char *, const char *);\nint strverscmp (const char *, const char *);\nvoid tdestroy(void *, void (*)(void *));\nint utimes(const char *path, const struct timeval times[2]);\nint versionsort(const struct dirent **, const struct dirent **);\nint iprintf(const char *__restrict, ...);\nextern char **environ;\nextern char **_environ;\nchar *fgets_unlocked(char *, int, FILE *);\nint fputs_unlocked(const char *, FILE *);\nwint_t fgetwc_unlocked (FILE *);\nwchar_t *fgetws_unlocked (wchar_t *__restrict, int, FILE *__restrict);\nint fpurge(FILE *);\nvoid *memrchr(const void *, int, size_t);\nwint_t fputwc_unlocked (wchar_t, FILE *);\nint fputws_unlocked (const wchar_t *__restrict, FILE *__restrict);\nwint_t getwc_unlocked (FILE *);\nwint_t getwchar_unlocked (void);\nint hcreate_r(size_t, struct hsearch_data *);\nvoid hdestroy_r(struct hsearch_data *);\nint hsearch_r(ENTRY, ACTION, ENTRY **, struct hsearch_data *);\nlong double lgammal_r(long double, int*);\nextern char *program_invocation_short_name, *program_invocation_name;\nwint_t putwc_unlocked (wchar_t, FILE *);\nwint_t putwchar_unlocked (wchar_t);\nvoid qsort_r(void *base, size_t nmemb, size_t size,\n           int (*compar)(const void *, const void *, void *),\n           void *arg);\nchar *strchrnul(const char *, int);\nextern char *__wasilibc_cwd;\nextern char **__wasilibc_environ;\nvoid __qsort_r (void *, size_t, size_t, int (*)(const void *, const void *, void *), void *);\n\nint __stack_chk_guard;\nvoid __stack_chk_fail(void);\n\n// qsort is completely missing from Zig's musl, but it is assumed\n// to be there by wasi. This breaks things.  Fortnately, zig has\n// qsort_r, and it is trivial to implement qsort in terms of qsort_r:\n// Unfortunately, I can't get this to work from dynamically loaded\n// libraries because calling the function pointer doesn't work.\n\ntypedef int (*qsort_compar)(const void *, const void *);\nint qsort_r_compar(const void * a, const void * b, void * compar) {\n  return (*(qsort_compar)compar)(a,b);\n}\nvoid qsort(void *base, size_t nmemb, size_t size,\n           int (*compar)(const void *, const void *)) {\n  qsort_r(base, nmemb, size, qsort_r_compar, compar);\n}\n\nint mkstemp(char *template);\nvoid __SIG_IGN(int);\n";
    s += "\n";
    s += (0, wasm_export_1.default)((symbols + "\n" + posix).split("\n"));
    s += "WASM_EXPORT(__stack_chk_guard, __stack_chk_guard);";
    console.log(s);
}
// Extra things we added to our posix compat layer, since they are
// missing from wasi-zig-libc:
var posix = "\nqsort\nflockfile\nftrylockfile\nfunlockfile\nstrsignal\n__stack_chk_fail\nsecure_getenv\nstrunvis\nstrnvis\nstrvis\ncfgetispeed\ncfgetospeed\ntcgetattr\ntcsetattr\ntextdomain\ngettext\ndgettext\ndcgettext\nmkstemp\nsigemptyset\nbindtextdomain\nmmap\nmunmap\ngeteuid\nfchown\n";
// All headers from zig/dist/lib/zig/libc/include/wasm-wasi-musl except signal/thread ones.
// Also, include our posix-wasm.h, which fills in declarations for things in posix that are
// missing from libc-wasi-zig.
var headers = "\nposix-wasm.h\nalloca.h\nar.h\narpa/telnet.h\narpa/ftp.h\narpa/inet.h\narpa/tftp.h\narpa/nameser.h\narpa/nameser_compat.h\nassert.h\nbits/ipcstat.h\nbits/ioctl.h\nbits/reg.h\nbits/ioctl_fix.h\nbits/float.h\nbits/limits.h\nbits/fcntl.h\nbits/stat.h\nbits/signal.h\nbits/dirent.h\nbits/mman.h\nbits/io.h\nbits/posix.h\nbits/resource.h\nbits/poll.h\nbits/alltypes.h\nbits/socket.h\nbits/stdint.h\nbits/hwcap.h\nbyteswap.h\ncomplex.h\ncpio.h\ncrypt.h\nctype.h\ndirent.h\nendian.h\nerr.h\nerrno.h\nfcntl.h\nfeatures.h\nfenv.h\nfloat.h\nfmtmsg.h\nfnmatch.h\nftw.h\ngetopt.h\nglob.h\niconv.h\nifaddrs.h\ninttypes.h\niso646.h\nlanginfo.h\nlibgen.h\nlibintl.h\nlimits.h\nlocale.h\nmalloc.h\nmath.h\nmemory.h\nmonetary.h\nmqueue.h\nnetinet/tcp.h\nnetinet/ip_icmp.h\nnetinet/igmp.h\nnetinet/in.h\nnetinet/ip6.h\nnetinet/icmp6.h\nnetinet/ip.h\nnetinet/in_systm.h\nnetinet/udp.h\nnetpacket/packet.h\nnl_types.h\npoll.h\nregex.h\nsched.h\nsearch.h\nsemaphore.h\nspawn.h\nstdalign.h\nstdbool.h\nstdc-predef.h\nstdint.h\nstdio.h\nstdio_ext.h\nstdlib.h\nstdnoreturn.h\nstring.h\nstrings.h\nstropts.h\nsyscall.h\nsysexits.h\nsys/time.h\nsys/ioctl.h\nsys/reg.h\nsys/timeb.h\nsys/uio.h\nsys/types.h\nsys/times.h\nsys/eventfd.h\nsys/sysinfo.h\nsys/fcntl.h\nsys/file.h\nsys/stat.h\nsys/mman.h\nsys/stropts.h\nsys/un.h\nsys/utsname.h\nsys/timex.h\nsys/param.h\nsys/ttydefaults.h\nsys/resource.h\nsys/errno.h\nsys/poll.h\nsys/syscall.h\nsys/socket.h\nsys/dir.h\nsys/random.h\nsys/select.h\ntar.h\ntgmath.h\ntime.h\nuchar.h\nunistd.h\nutime.h\nvalues.h\nwasi/libc-environ.h\nwasi/libc-find-relpath.h\nwasi/libc-nocwd.h\nwasi/api.h\nwasi/libc.h\nwchar.h\nwctype.h\n";
// I copied libc.a by watching the output of zig build something targeting
// wasm-wasi with an empty cache.  Then this gets ALL symbols that are defined
// in the wasm32-wasi library from clang/musl/zig that don't start with a double
// underscore or _IO_ (no clue what those are).  The symbols ending in 64 seems
// to all be #defined to the non-64 ones, so we exclude those.
//
// nm -gU libc.a |grep -v : | awk '{print $3}' |sort|uniq |grep -v ^__ |grep -v ^_IO_ |grep -v 64$  > all-symbols.txt && nm -gU libc.a |grep -v : | awk '{print $3}' |sort|uniq |grep  ^__wasi >> all-symbols.txt
//
// NOTE: I'm often finding that excluding symbols starting with dunder __ was a mistake,
// since they often pop up with new dynamic libraries, presumably since they are the
// targets of #define.
var symbols = "\n__assert_fail\nsigaction\nsignal\n__SIG_IGN\n__qsort_r\n__ctype_get_mb_cur_max\n_CLOCK_MONOTONIC\n_CLOCK_PROCESS_CPUTIME_ID\n_CLOCK_REALTIME\n_CLOCK_THREAD_CPUTIME_ID\n_Exit\n_environ\n_exit\n_flushlbf\na64l\nabort\nabs\naccess\nacos\nacosf\nacosh\nacoshf\nacoshl\nacosl\naligned_alloc\nalphasort\narc4random\narc4random_buf\narc4random_uniform\nasctime\nasctime_r\nasin\nasinf\nasinh\nasinhf\nasinhl\nasinl\nasprintf\nat_quick_exit\natan\natan2\natan2f\natan2l\natanf\natanh\natanhf\natanhl\natanl\natexit\natof\natoi\natol\natoll\nbasename\nbcmp\nbcopy\nbsearch\nbtowc\nbzero\nc16rtomb\nc32rtomb\ncabs\ncabsf\ncabsl\ncacos\ncacosf\ncacosh\ncacoshf\ncacoshl\ncacosl\ncalloc\ncarg\ncargf\ncargl\ncasin\ncasinf\ncasinh\ncasinhf\ncasinhl\ncasinl\ncatan\ncatanf\ncatanh\ncatanhf\ncatanhl\ncatanl\ncatclose\ncatgets\ncatopen\ncbrt\ncbrtf\ncbrtl\nccos\nccosf\nccosh\nccoshf\nccoshl\nccosl\nceil\nceilf\nceill\ncexp\ncexpf\ncexpl\nchdir\ncimag\ncimagf\ncimagl\nclearenv\nclearerr\nclearerr_unlocked\nclock_getres\nclock_gettime\nclock_nanosleep\nclog\nclogf\nclogl\nclose\nclosedir\nconfstr\nconj\nconjf\nconjl\ncopysign\ncopysignf\ncopysignl\ncos\ncosf\ncosh\ncoshf\ncoshl\ncosl\ncpow\ncpowf\ncpowl\ncproj\ncprojf\ncprojl\ncreal\ncrealf\ncreall\ncreat\ncrypt\ncrypt_r\ncsin\ncsinf\ncsinh\ncsinhf\ncsinhl\ncsinl\ncsqrt\ncsqrtf\ncsqrtl\nctan\nctanf\nctanh\nctanhf\nctanhl\nctanl\nctime\nctime_r\ndifftime\ndirfd\ndirname\ndiv\ndprintf\ndrand48\ndrem\ndremf\nduplocale\necvt\nencrypt\nenviron\nerand48\nerf\nerfc\nerfcf\nerfcl\nerff\nerfl\nerrno\nexit\nexp\nexp10\nexp10f\nexp10l\nexp2\nexp2f\nexp2l\nexpf\nexpl\nexplicit_bzero\nexpm1\nexpm1f\nexpm1l\nfabs\nfabsf\nfabsl\nfaccessat\nfclose\nfcntl\nfcvt\nfdatasync\nfdclosedir\nfdim\nfdimf\nfdiml\nfdopen\nfdopendir\nfeclearexcept\nfegetenv\nfegetexceptflag\nfegetround\nfeholdexcept\nfeof\nfeof_unlocked\nferaiseexcept\nferror\nferror_unlocked\nfesetenv\nfesetexceptflag\nfesetround\nfetestexcept\nfeupdateenv\nfflush\nfflush_unlocked\nffs\nffsl\nffsll\nfgetc\nfgetc_unlocked\nfgetln\nfgetpos\nfgets\nfgets_unlocked\nfgetwc\nfgetwc_unlocked\nfgetws\nfgetws_unlocked\nfileno\nfileno_unlocked\nfinite\nfinitef\nfloor\nfloorf\nfloorl\nfma\nfmaf\nfmal\nfmax\nfmaxf\nfmaxl\nfmemopen\nfmin\nfminf\nfminl\nfmod\nfmodf\nfmodl\nfmtmsg\nfnmatch\nfopen\nfopencookie\nfpathconf\nfprintf\nfpurge\nfputc\nfputc_unlocked\nfputs\nfputs_unlocked\nfputwc\nfputwc_unlocked\nfputws\nfputws_unlocked\nfread\nfread_unlocked\nfree\nfreelocale\nfreopen\nfrexp\nfrexpf\nfrexpl\nfscanf\nfseek\nfseeko\nfsetpos\nfstat\nfstatat\nfsync\nftell\nftello\nftime\nftruncate\nfutimens\nfwide\nfwprintf\nfwrite\nfwrite_unlocked\nfwscanf\ngcvt\nget_avphys_pages\nget_nprocs\nget_nprocs_conf\nget_phys_pages\ngetc\ngetc_unlocked\ngetchar\ngetchar_unlocked\ngetcwd\ngetdate\ngetdate_err\ngetdelim\ngetdomainname\ngetentropy\ngetenv\ngethostid\ngetline\ngetopt\ngetopt_long\ngetopt_long_only\ngetsockopt\ngetsubopt\ngettimeofday\ngetw\ngetwc\ngetwc_unlocked\ngetwchar\ngetwchar_unlocked\nglob\nglobfree\ngmtime\ngmtime_r\nhcreate\nhcreate_r\nhdestroy\nhdestroy_r\nhsearch\nhsearch_r\nhtonl\nhtons\nhypot\nhypotf\nhypotl\niconv\niconv_close\niconv_open\nilogb\nilogbf\nilogbl\nimaxabs\nimaxdiv\nin6addr_any\nin6addr_loopback\nindex\ninet_aton\ninet_ntop\ninet_pton\ninitstate\ninsque\nioctl\niprintf\nisalnum\nisalnum_l\nisalpha\nisalpha_l\nisascii\nisatty\nisblank\nisblank_l\niscntrl\niscntrl_l\nisdigit\nisdigit_l\nisgraph\nisgraph_l\nislower\nislower_l\nisprint\nisprint_l\nispunct\nispunct_l\nisspace\nisspace_l\nisupper\nisupper_l\niswalnum\niswalnum_l\niswalpha\niswalpha_l\niswblank\niswblank_l\niswcntrl\niswcntrl_l\niswctype\niswctype_l\niswdigit\niswdigit_l\niswgraph\niswgraph_l\niswlower\niswlower_l\niswprint\niswprint_l\niswpunct\niswpunct_l\niswspace\niswspace_l\niswupper\niswupper_l\niswxdigit\niswxdigit_l\nisxdigit\nisxdigit_l\nj0\nj0f\nj1\nj1f\njn\njnf\njrand48\nl64a\nlabs\nlcong48\nldexp\nldexpf\nldexpl\nldiv\nlfind\nlgamma\nlgamma_r\nlgammaf\nlgammaf_r\nlgammal\nlgammal_r\nlink\nlinkat\nllabs\nlldiv\nllrint\nllrintf\nllrintl\nllround\nllroundf\nllroundl\nlocaleconv\nlocaltime\nlocaltime_r\nlog\nlog10\nlog10f\nlog10l\nlog1p\nlog1pf\nlog1pl\nlog2\nlog2f\nlog2l\nlogb\nlogbf\nlogbl\nlogf\nlogl\nlrand48\nlrint\nlrintf\nlrintl\nlround\nlroundf\nlroundl\nlsearch\nlseek\nlstat\nmalloc\nmalloc_usable_size\nmblen\nmbrlen\nmbrtoc16\nmbrtoc32\nmbrtowc\nmbsinit\nmbsnrtowcs\nmbsrtowcs\nmbstowcs\nmbtowc\nmemccpy\nmemchr\nmemcmp\nmemcpy\nmemmem\nmemmove\nmempcpy\nmemrchr\nmemset\nmkdir\nmkdirat\nmktime\nmodf\nmodff\nmodfl\nmrand48\nnan\nnanf\nnanl\nnanosleep\nnearbyint\nnearbyintf\nnearbyintl\nnewlocale\nnextafter\nnextafterf\nnextafterl\nnexttoward\nnexttowardf\nnexttowardl\nnftw\nnl_langinfo\nnl_langinfo_l\nnrand48\nntohl\nntohs\nopen\nopen_memstream\nopen_wmemstream\nopenat\nopendir\nopendirat\noptarg\nopterr\noptind\noptopt\noptreset\npathconf\nperror\npoll\nposix_close\nposix_fadvise\nposix_fallocate\nposix_memalign\npow\npow10\npow10f\npow10l\npowf\npowl\npread\npreadv\nprintf\nprogram_invocation_name\nprogram_invocation_short_name\npselect\nputc\nputc_unlocked\nputchar\nputchar_unlocked\nputenv\nputs\nputw\nputwc\nputwc_unlocked\nputwchar\nputwchar_unlocked\npwrite\npwritev\nqsort_r\nquick_exit\nrand\nrand_r\nrandom\nread\nreaddir\nreadlink\nreadlinkat\nreadv\nrealloc\nreallocarray\nrecv\nregcomp\nregerror\nregexec\nregfree\nremainder\nremainderf\nremainderl\nremove\nremque\nremquo\nremquof\nremquol\nrename\nrenameat\nrewind\nrewinddir\nrindex\nrint\nrintf\nrintl\nrmdir\nround\nroundf\nroundl\nsbrk\nscalb\nscalbf\nscalbln\nscalblnf\nscalblnl\nscalbn\nscalbnf\nscalbnl\nscandir\nscandirat\nscanf\nsched_yield\nseed48\nseekdir\nselect\nsend\nsetbuf\nsetbuffer\nsetenv\nsetkey\nsetlinebuf\nsetlocale\nsetstate\nsetvbuf\nshutdown\nsigngam\nsignificand\nsignificandf\nsin\nsincos\nsincosf\nsincosl\nsinf\nsinh\nsinhf\nsinhl\nsinl\nsleep\nsnprintf\nsprintf\nsqrt\nsqrtf\nsqrtl\nsrand\nsrand48\nsrandom\nsscanf\nstat\nstderr\nstdin\nstdout\nstpcpy\nstpncpy\nstrcasecmp\nstrcasecmp_l\nstrcasestr\nstrcat\nstrchr\nstrchrnul\nstrcmp\nstrcoll\nstrcoll_l\nstrcpy\nstrcspn\nstrdup\nstrerror\nstrerror_l\nstrerror_r\nstrfmon\nstrfmon_l\nstrftime\nstrftime_l\nstrlcat\nstrlcpy\nstrlen\nstrncasecmp\nstrncasecmp_l\nstrncat\nstrncmp\nstrncpy\nstrndup\nstrnlen\nstrpbrk\nstrptime\nstrrchr\nstrsep\nstrspn\nstrstr\nstrtod\nstrtof\nstrtoimax\nstrtok\nstrtok_r\nstrtol\nstrtold\nstrtoll\nstrtoul\nstrtoull\nstrtoumax\nstrverscmp\nstrxfrm\nstrxfrm_l\nswab\nswprintf\nswscanf\nsymlink\nsymlinkat\nsysconf\ntan\ntanf\ntanh\ntanhf\ntanhl\ntanl\ntdelete\ntdestroy\ntelldir\ntfind\ntgamma\ntgammaf\ntgammal\ntime\ntimegm\ntimespec_get\ntoascii\ntolower\ntolower_l\ntoupper\ntoupper_l\ntowctrans\ntowctrans_l\ntowlower\ntowlower_l\ntowupper\ntowupper_l\ntrunc\ntruncate\ntruncf\ntruncl\ntsearch\ntwalk\nuname\nungetc\nungetwc\nunlink\nunlinkat\nunsetenv\nuselocale\nusleep\nutime\nutimensat\nutimes\nvasprintf\nvdprintf\nversionsort\nvfprintf\nvfscanf\nvfwprintf\nvfwscanf\nvprintf\nvscanf\nvsnprintf\nvsprintf\nvsscanf\nvswprintf\nvswscanf\nvwprintf\nvwscanf\nwcpcpy\nwcpncpy\nwcrtomb\nwcscasecmp\nwcscasecmp_l\nwcscat\nwcschr\nwcscmp\nwcscoll\nwcscoll_l\nwcscpy\nwcscspn\nwcsdup\nwcsftime\nwcsftime_l\nwcslen\nwcsncasecmp\nwcsncasecmp_l\nwcsncat\nwcsncmp\nwcsncpy\nwcsnlen\nwcsnrtombs\nwcspbrk\nwcsrchr\nwcsrtombs\nwcsspn\nwcsstr\nwcstod\nwcstof\nwcstoimax\nwcstok\nwcstol\nwcstold\nwcstoll\nwcstombs\nwcstoul\nwcstoull\nwcstoumax\nwcswcs\nwcswidth\nwcsxfrm\nwcsxfrm_l\nwctob\nwctomb\nwctrans\nwctrans_l\nwctype\nwctype_l\nwcwidth\nwmemchr\nwmemcmp\nwmemcpy\nwmemmove\nwmemset\nwprintf\nwrite\nwritev\nwscanf\ny0\ny0f\ny1\ny1f\nyn\nynf\n__wasi_args_get\n__wasi_args_sizes_get\n__wasi_clock_res_get\n__wasi_clock_time_get\n__wasi_environ_get\n__wasi_environ_sizes_get\n__wasi_fd_advise\n__wasi_fd_allocate\n__wasi_fd_close\n__wasi_fd_datasync\n__wasi_fd_fdstat_get\n__wasi_fd_fdstat_set_flags\n__wasi_fd_fdstat_set_rights\n__wasi_fd_filestat_get\n__wasi_fd_filestat_set_size\n__wasi_fd_filestat_set_times\n__wasi_fd_pread\n__wasi_fd_prestat_dir_name\n__wasi_fd_prestat_get\n__wasi_fd_pwrite\n__wasi_fd_read\n__wasi_fd_readdir\n__wasi_fd_renumber\n__wasi_fd_seek\n__wasi_fd_sync\n__wasi_fd_tell\n__wasi_fd_write\n__wasi_path_create_directory\n__wasi_path_filestat_get\n__wasi_path_filestat_set_times\n__wasi_path_link\n__wasi_path_open\n__wasi_path_readlink\n__wasi_path_remove_directory\n__wasi_path_rename\n__wasi_path_symlink\n__wasi_path_unlink_file\n__wasi_poll_oneoff\n__wasi_proc_exit\n__wasi_random_get\n__wasi_sched_yield\n__wasi_sock_recv\n__wasi_sock_send\n__wasi_sock_shutdown\n__wasilibc_access\n__wasilibc_cwd\n__wasilibc_ensure_environ\n__wasilibc_environ\n__wasilibc_fd_renumber\n__wasilibc_find_abspath\n__wasilibc_find_relpath\n__wasilibc_find_relpath_alloc\n__wasilibc_initialize_environ\n__wasilibc_link\n__wasilibc_link_newat\n__wasilibc_link_oldat\n__wasilibc_nocwd___wasilibc_rmdirat\n__wasilibc_nocwd___wasilibc_unlinkat\n__wasilibc_nocwd_faccessat\n__wasilibc_nocwd_fstatat\n__wasilibc_nocwd_linkat\n__wasilibc_nocwd_mkdirat_nomode\n__wasilibc_nocwd_openat_nomode\n__wasilibc_nocwd_opendirat\n__wasilibc_nocwd_readlinkat\n__wasilibc_nocwd_renameat\n__wasilibc_nocwd_scandirat\n__wasilibc_nocwd_symlinkat\n__wasilibc_nocwd_utimensat\n__wasilibc_open_nomode\n__wasilibc_register_preopened_fd\n__wasilibc_rename_newat\n__wasilibc_rename_oldat\n__wasilibc_rmdirat\n__wasilibc_stat\n__wasilibc_tell\n__wasilibc_unlinkat\n__wasilibc_utimens\n\n\n";
main();
//# sourceMappingURL=libc.js.map